// Generated by CoffeeScript 1.12.7
var feedback, scoring;

scoring = require('./scoring');

feedback = {
  default_feedback: {
    warning: '',
    suggestions: ['default_suggestion']
  },
  get_feedback: function(score, sequence) {
    var extra_feedback, i, len, longest_match, match, ref;
    if (sequence.length === 0) {
      return this.default_feedback;
    }
    if (score > 2) {
      return {
        warning: '',
        suggestions: []
      };
    }
    longest_match = sequence[0];
    ref = sequence.slice(1);
    for (i = 0, len = ref.length; i < len; i++) {
      match = ref[i];
      if (match.token.length > longest_match.token.length) {
        longest_match = match;
      }
    }
    feedback = this.get_match_feedback(longest_match, sequence.length === 1);
    extra_feedback = 'suggestion_too_weak';
    if (feedback != null) {
      feedback.suggestions.unshift(extra_feedback);
      if (feedback.warning == null) {
        feedback.warning = '';
      }
    } else {
      feedback = {
        warning: '',
        suggestions: [extra_feedback]
      };
    }
    return feedback;
  },
  get_match_feedback: function(match, is_sole_match) {
    var layout, warning;
    switch (match.pattern) {
      case 'dictionary':
        return this.get_dictionary_match_feedback(match, is_sole_match);
      case 'spatial':
        layout = match.graph.toUpperCase();
        warning = match.turns === 1 ? 'warning_straight_rows' : 'warning_short_pattern';
        return {
          warning: warning,
          suggestions: ['suggestion_short_pattern']
        };
      case 'repeat':
        warning = match.base_token.length === 1 ? 'warning_repeat' : 'warning_repeat_multichar';
        return {
          warning: warning,
          suggestions: ['suggestion_repeat']
        };
      case 'sequence':
        return {
          warning: 'warning_sequence',
          suggestions: ['suggestion_sequence']
        };
      case 'regex':
        if (match.regex_name === 'recent_year') {
          return {
            warning: 'warning_recent_year',
            suggestions: ['suggestion_recent_year']
          };
        }
        break;
      case 'date':
        return {
          warning: 'warning_date',
          suggestions: ['suggestion_date']
        };
    }
  },
  get_dictionary_match_feedback: function(match, is_sole_match) {
    var result, suggestions, warning, word;
    warning = match.dictionary_name === 'passwords' ? is_sole_match && !match.l33t && !match.reversed ? match.rank <= 10 ? 'warning_top_10_common_password' : match.rank <= 100 ? 'warning_top_100_common_password' : 'warning_common_password' : match.guesses_log10 <= 4 ? 'warning_common_password_similar' : void 0 : match.dictionary_name === 'world_wikipedia' ? is_sole_match ? 'warning_word' : void 0 : '';
    suggestions = [];
    word = match.token;
    if (word.match(scoring.START_UPPER)) {
      suggestions.push('suggestion_uppercase');
    } else if (word.match(scoring.ALL_UPPER) && word.toLowerCase() !== word) {
      suggestions.push('suggestion_all_uppercase');
    }
    if (match.reversed && match.token.length >= 4) {
      suggestions.push('suggestion_reverse_word');
    }
    if (match.l33t) {
      suggestions.push('suggestion_predictable_substitution');
    }
    result = {
      warning: warning,
      suggestions: suggestions
    };
    return result;
  }
};

module.exports = feedback;

//# sourceMappingURL=feedback.js.map
